/* Lengths of various fields */
#define ERRLEN 64
#define NAMELEN 28
#define AUTHENTLEN 13
#define TICKETLEN 72
#define DOMLEN 48
#define CHALLEN 8
#define DIRLEN 116

/* Directory qid must have a certain bit set: */
#define DIRMASK 0x80000000

/* Append only bit */
#define AOMASK 0x40000000

/* Exclusive use bit */
#define EUMASK 0x20000000

#define ORCLOSE 0x40
#define OTRUNC 0x10

#define INFERNO

#ifdef INFERNO
#define PORT_9P 6666
#else
#define PORT_9P 564
#endif

//typedef unsigned short ushort;

typedef
struct	Fcall
{
	char	type;
	short	fid;
	ushort	tag;
	union {
		struct {
			ushort	oldtag;		/* Tflush */
			//Qid	qid;		/* Rattach, Rwalk, Ropen, Rcreate */
			long long int	qid;		/* Rattach, Rwalk, Ropen, Rcreate */
			int		qidpath;
			int		qidver;
			char	rauth[AUTHENTLEN];	/* Rattach */
		} rr;
		struct {
			char	uname[NAMELEN];		/* Tattach */
			char	aname[NAMELEN];		/* Tattach */
			char	ticket[TICKETLEN];	/* Tattach */
			char	auth[AUTHENTLEN];	/* Tattach */
		} at;
		struct {
			char	ename[ERRLEN];		/* Rerror */
			char	authid[NAMELEN];	/* Rsession */
			char	authdom[DOMLEN];	/* Rsession */
			char	chal[CHALLEN];		/* Tsession/Rsession */
		} au;
		struct {
			long	perm;		/* Tcreate */ 
			short	newfid;		/* Tclone, Tclwalk */
			char	name[NAMELEN];	/* Twalk, Tclwalk, Tcreate */
			char	mode;		/* Tcreate, Topen */
		} cc;
		struct {
			long	offset;		/* Tread, Twrite */
			long	count;		/* Tread, Twrite, Rread */
			char	*data;		/* Twrite, Rread */
		} rw;
		struct {
			char	stat[DIRLEN];	/* Twstat, Rstat */
		} st;
	} u;
} Fcall;

#define	MAXFDATA	(8*1024)
#define	MAXMSG		160	/* max header sans data */
#define	NOTAG		0xFFFF	/* Dummy tag */

enum
{
#ifdef INFERNO
	Tnop,		/*  0 */
	Rnop,		/*  1 */
	Terror,		/*  2, illegal */
	Rerror,		/*  3 */
	Tflush,		/*  4 */
	Rflush,		/*  5 */
	Tclone,		/*  6 */
	Rclone,		/*  7 */
	Twalk,		/*  8 */
	Rwalk,		/*  9 */
	Topen,		/* 10 */
	Ropen,		/* 11 */
	Tcreate,	/* 12 */
	Rcreate,	/* 13 */
	Tread,		/* 14 */
	Rread,		/* 15 */
	Twrite,		/* 16 */
	Rwrite,		/* 17 */
	Tclunk,		/* 18 */
	Rclunk,		/* 19 */
	Tremove,	/* 20 */
	Rremove,	/* 21 */
	Tstat,		/* 22 */
	Rstat,		/* 23 */
	Twstat,		/* 24 */
	Rwstat,		/* 25 */
	Tsession,	/* 26 */
	Rsession,	/* 27 */
	Tattach,	/* 28 */
	Rattach,	/* 29 */
	Tmax,
	Tclwalk,	/* 28 */
	Rclwalk, 	/* 29 */
	Tauth,	/* 28 */
	Rauth	/* 29 */
#else
#endif
};

